diff --git a/qtcharts/qvbarmodelmapper-members.html b/qtcharts/qvbarmodelmapper-members.html
index 5281dbf..ca951a3 100644
--- a/qtcharts/qvbarmodelmapper-members.html
+++ b/qtcharts/qvbarmodelmapper-members.html
@@ -39,107 +39,26 @@
 <p>This is the complete list of members for <a href="qvbarmodelmapper.html">QVBarModelMapper</a>, including inherited members.</p>
 <div class="table"><table class="propsummary">
 <tr><td class="topAlign"><ul>
-<li class="fn">typedef <span class="name"><b><a href="../qtcore/qobject.html#QObjectList-typedef">QObjectList</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#QT_NO_NARROWING_CONVERSIONS_IN_CONNECT">QT_NO_NARROWING_CONVERSIONS_IN_CONNECT</a></b></span></li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#QVBarModelMapper">QVBarModelMapper</a></b></span>(QObject *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_CLASSINFO">Q_CLASSINFO</a></b></span>(, )</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_DISABLE_COPY">Q_DISABLE_COPY</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_DISABLE_COPY_MOVE">Q_DISABLE_COPY_MOVE</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_DISABLE_MOVE">Q_DISABLE_MOVE</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_EMIT">Q_EMIT</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_ENUM">Q_ENUM</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_ENUM_NS">Q_ENUM_NS</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_FLAG">Q_FLAG</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_FLAG_NS">Q_FLAG_NS</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_GADGET">Q_GADGET</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_INTERFACES">Q_INTERFACES</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_INVOKABLE">Q_INVOKABLE</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_NAMESPACE">Q_NAMESPACE</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_NAMESPACE_EXPORT">Q_NAMESPACE_EXPORT</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_OBJECT">Q_OBJECT</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_PROPERTY">Q_PROPERTY</a></b></span>(<i>...</i>)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_REVISION">Q_REVISION</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_SET_OBJECT_NAME">Q_SET_OBJECT_NAME</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_SIGNAL">Q_SIGNAL</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_SIGNALS">Q_SIGNALS</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_SLOT">Q_SLOT</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#Q_SLOTS">Q_SLOTS</a></b></span></li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#deleteLater">deleteLater</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#destroyed">destroyed</a></b></span>(QObject *)</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstBarSetColumnChanged">firstBarSetColumnChanged</a></b></span>()</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstRowChanged">firstRowChanged</a></b></span>()</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#lastBarSetColumnChanged">lastBarSetColumnChanged</a></b></span>()</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#modelReplaced">modelReplaced</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#objectNameChanged">objectNameChanged</a></b></span>(const QString &amp;)</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#rowCountChanged">rowCountChanged</a></b></span>()</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#seriesReplaced">seriesReplaced</a></b></span>()</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#blockSignals">blockSignals</a></b></span>(bool ) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#childEvent">childEvent</a></b></span>(QChildEvent *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#children">children</a></b></span>() const : const QObjectList &amp;</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect">connect</a></b></span>(const QObject *, const char *, const QObject *, const char *, Qt::ConnectionType ) : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect-1">connect</a></b></span>(const QObject *, const QMetaMethod &amp;, const QObject *, const QMetaMethod &amp;, Qt::ConnectionType ) : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect-2">connect</a></b></span>(const QObject *, const char *, const char *, Qt::ConnectionType ) const : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect-3">connect</a></b></span>(const QObject *, PointerToMemberFunction , const QObject *, PointerToMemberFunction , Qt::ConnectionType ) : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect-4">connect</a></b></span>(const QObject *, PointerToMemberFunction , Functor ) : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connect-5">connect</a></b></span>(const QObject *, PointerToMemberFunction , const QObject *, Functor , Qt::ConnectionType ) : QMetaObject::Connection</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#connectNotify">connectNotify</a></b></span>(const QMetaMethod &amp;)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#customEvent">customEvent</a></b></span>(QEvent *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect">disconnect</a></b></span>(const QObject *, const char *, const QObject *, const char *) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect-1">disconnect</a></b></span>(const QObject *, const QMetaMethod &amp;, const QObject *, const QMetaMethod &amp;) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect-2">disconnect</a></b></span>(const char *, const QObject *, const char *) const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect-3">disconnect</a></b></span>(const QObject *, const char *) const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect-4">disconnect</a></b></span>(const QMetaObject::Connection &amp;) : bool</li>
-</ul></td><td class="topAlign"><ul>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnect-5">disconnect</a></b></span>(const QObject *, PointerToMemberFunction , const QObject *, PointerToMemberFunction ) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#disconnectNotify">disconnectNotify</a></b></span>(const QMetaMethod &amp;)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#dumpObjectInfo">dumpObjectInfo</a></b></span>() const</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#dumpObjectTree">dumpObjectTree</a></b></span>() const</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#dynamicPropertyNames">dynamicPropertyNames</a></b></span>() const : QList&lt;QByteArray&gt;</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#event">event</a></b></span>(QEvent *) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#eventFilter">eventFilter</a></b></span>(QObject *, QEvent *) : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#findChild">findChild</a></b></span>(const QString &amp;, Qt::FindChildOptions ) const : T</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#findChildren">findChildren</a></b></span>(const QString &amp;, Qt::FindChildOptions ) const : QList&lt;T&gt;</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#findChildren-2">findChildren</a></b></span>(const QRegularExpression &amp;, Qt::FindChildOptions ) const : QList&lt;T&gt;</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstBarSetColumn-prop">firstBarSetColumn</a></b></span>() const : int</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstRow-prop">firstRow</a></b></span>() const : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#inherits">inherits</a></b></span>(const char *) const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#installEventFilter">installEventFilter</a></b></span>(QObject *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#isSignalConnected">isSignalConnected</a></b></span>(const QMetaMethod &amp;) const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#isWidgetType">isWidgetType</a></b></span>() const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#isWindowType">isWindowType</a></b></span>() const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#killTimer">killTimer</a></b></span>(int )</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#lastBarSetColumn-prop">lastBarSetColumn</a></b></span>() const : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#metaObject">metaObject</a></b></span>() const : const QMetaObject *</li>
+</ul></td><td class="topAlign"><ul>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#model-prop">model</a></b></span>() const : QAbstractItemModel *</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#moveToThread">moveToThread</a></b></span>(QThread *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#objectName-prop">objectName</a></b></span>() const : QString</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#parent">parent</a></b></span>() const : QObject *</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#property">property</a></b></span>(const char *) const : QVariant</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#qFindChildren-1">qFindChildren</a></b></span>(const QObject *, const QRegExp &amp;) : QList&lt;T&gt;</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#qobject_cast">qobject_cast</a></b></span>(QObject *) : T</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#qobject_cast-1">qobject_cast</a></b></span>(const QObject *) : T</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#receivers">receivers</a></b></span>(const char *) const : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#removeEventFilter">removeEventFilter</a></b></span>(QObject *)</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#rowCount-prop">rowCount</a></b></span>() const : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#sender">sender</a></b></span>() const : QObject *</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#senderSignalIndex">senderSignalIndex</a></b></span>() const : int</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#series-prop">series</a></b></span>() const : QAbstractBarSeries *</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstBarSetColumn-prop">setFirstBarSetColumn</a></b></span>(int )</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#firstRow-prop">setFirstRow</a></b></span>(int )</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#lastBarSetColumn-prop">setLastBarSetColumn</a></b></span>(int )</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#model-prop">setModel</a></b></span>(QAbstractItemModel *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#objectName-prop">setObjectName</a></b></span>(const QString &amp;)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#setParent">setParent</a></b></span>(QObject *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#setProperty">setProperty</a></b></span>(const char *, const QVariant &amp;) : bool</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#rowCount-prop">setRowCount</a></b></span>(int )</li>
 <li class="fn"><span class="name"><b><a href="qvbarmodelmapper.html#series-prop">setSeries</a></b></span>(QAbstractBarSeries *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#signalsBlocked">signalsBlocked</a></b></span>() const : bool</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#startTimer">startTimer</a></b></span>(int , Qt::TimerType ) : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#startTimer-1">startTimer</a></b></span>(std::chrono::milliseconds , Qt::TimerType ) : int</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#staticMetaObject-var">staticMetaObject</a></b></span> : </li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#thread">thread</a></b></span>() const : QThread *</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#timerEvent">timerEvent</a></b></span>(QTimerEvent *)</li>
-<li class="fn"><span class="name"><b><a href="../qtcore/qobject.html#tr">tr</a></b></span>(const char *, const char *, int ) : QString</li>
 </ul>
 </td></tr>
 </table></div>