diff --git a/qtwidgets/stylesheet-examples.html b/qtwidgets/stylesheet-examples.html
index c85fe8d..3a6f198 100644
--- a/qtwidgets/stylesheet-examples.html
+++ b/qtwidgets/stylesheet-examples.html
@@ -34,10 +34,6 @@
 <div class="content">
 <div class="line">
 <div class="content mainContent">
-  <link rel="prev" href="stylesheet-reference.html" />
-<p class="naviNextPrevious headerNavi">
-<a class="prevPage" href="stylesheet-reference.html">Qt Style Sheets Reference</a>
-</p><p/>
 <div class="sidebar">
 <div class="toc">
 <h3><a name="toc">Contents</a></h3>
@@ -772,8 +768,8 @@
 </pre>
 <a name="customizing-qprogressbar"></a>
 <h3 id="customizing-qprogressbar">Customizing QProgressBar</h3>
-<p>The <a href="qprogressbar.html">QProgressBar</a>'s <a href="stylesheet-reference.html#border-prop">border</a>, <a href="stylesheet-reference.html#chunk-sub">chunk</a>, and <a href="stylesheet-reference.html#text-align-prop">text-align</a> can be customized using style sheets. However, if one property or sub-control is customized, all the other properties or sub-controls must be customized as well.</p>
-<p class="centerAlign"><img src="images/progressBar-stylesheet.png" alt="" /></p><p>For example, we change the <a href="stylesheet-reference.html#border-prop">border</a> to grey and the <a href="stylesheet-reference.html#chunk-sub">chunk</a> to cerulean.</p>
+<p>The <a href="qprogressbar.html">QProgressBar</a>'s <a href="stylesheet-reference.html">border</a>, <a href="stylesheet-reference.html">chunk</a>, and <a href="stylesheet-reference.html">text-align</a> can be customized using style sheets. However, if one property or sub-control is customized, all the other properties or sub-controls must be customized as well.</p>
+<p class="centerAlign"><img src="images/progressBar-stylesheet.png" alt="" /></p><p>For example, we change the <a href="stylesheet-reference.html">border</a> to grey and the <a href="stylesheet-reference.html">chunk</a> to cerulean.</p>
 <pre class="cpp">
 
   <span class="type"><a href="qprogressbar.html">QProgressBar</a></span> {
@@ -787,7 +783,7 @@
   }
 
 </pre>
-<p>This leaves the <a href="stylesheet-reference.html#text-align-prop">text-align</a>, which we customize by positioning the text in the center of the progress bar.</p>
+<p>This leaves the <a href="stylesheet-reference.html">text-align</a>, which we customize by positioning the text in the center of the progress bar.</p>
 <pre class="cpp">
 
   <span class="type"><a href="qprogressbar.html">QProgressBar</a></span> {
@@ -797,8 +793,8 @@
   }
 
 </pre>
-<p>A <a href="stylesheet-reference.html#margin-prop">margin</a> can be included to obtain more visible chunks.</p>
-<p class="centerAlign"><img src="images/progressBar2-stylesheet.png" alt="" /></p><p>In the screenshot above, we use a <a href="stylesheet-reference.html#margin-prop">margin</a> of 0.5 pixels.</p>
+<p>A <a href="stylesheet-reference.html">margin</a> can be included to obtain more visible chunks.</p>
+<p class="centerAlign"><img src="images/progressBar2-stylesheet.png" alt="" /></p><p>In the screenshot above, we use a <a href="stylesheet-reference.html">margin</a> of 0.5 pixels.</p>
 <pre class="cpp">
 
   <span class="type"><a href="qprogressbar.html">QProgressBar</a></span><span class="operator">::</span>chunk {
@@ -893,7 +889,7 @@
 </pre>
 <a name="customizing-qscrollbar"></a>
 <h3 id="customizing-qscrollbar">Customizing QScrollBar</h3>
-<p>The <a href="qscrollbar.html">QScrollBar</a> can be styled using its subcontrols like <a href="stylesheet-reference.html#handle-sub">handle</a>, <a href="stylesheet-reference.html#add-line-sub">add-line</a>, <a href="stylesheet-reference.html#sub-line-sub">sub-line</a>, and so on. Note that if one property or sub-control is customized, all the other properties or sub-controls must be customized as well.</p>
+<p>The <a href="qscrollbar.html">QScrollBar</a> can be styled using its subcontrols like <a href="stylesheet-reference.html">handle</a>, <a href="stylesheet-reference.html">add-line</a>, <a href="stylesheet-reference.html">sub-line</a>, and so on. Note that if one property or sub-control is customized, all the other properties or sub-controls must be customized as well.</p>
 <p class="centerAlign"><img src="images/stylesheet-scrollbar1.png" alt="" /></p><p>The scroll bar above has been styled in aquamarine with a solid grey border.</p>
 <pre class="cpp">
 
@@ -924,7 +920,7 @@
   }
 
 </pre>
-<p>The <a href="stylesheet-reference.html#left-arrow-sub">left-arrow</a> and <a href="stylesheet-reference.html#right-arrow-sub">right-arrow</a> have a solid grey border with a white background. As an alternative, you could also embed the image of an arrow.</p>
+<p>The <a href="stylesheet-reference.html">left-arrow</a> and <a href="stylesheet-reference.html">right-arrow</a> have a solid grey border with a white background. As an alternative, you could also embed the image of an arrow.</p>
 <pre class="cpp">
 
   <span class="type"><a href="qscrollbar.html">QScrollBar</a></span>:left<span class="operator">-</span>arrow:horizontal<span class="operator">,</span> <span class="type"><a href="qscrollbar.html">QScrollBar</a></span><span class="operator">::</span>right<span class="operator">-</span>arrow:horizontal {
@@ -1377,7 +1373,7 @@
 <a name="customizing-qtableview"></a>
 <h3 id="customizing-qtableview">Customizing QTableView</h3>
 <p>Suppose we'd like our selected item in <a href="qtableview.html">QTableView</a> to have bubblegum pink fade to white as its background.</p>
-<p class="centerAlign"><img src="images/tableWidget-stylesheet.png" alt="" /></p><p>This is possible with the <a href="stylesheet-reference.html#selection-background-color-prop">selection-background-color</a> property and the syntax required is:</p>
+<p class="centerAlign"><img src="images/tableWidget-stylesheet.png" alt="" /></p><p>This is possible with the <a href="stylesheet-reference.html">selection-background-color</a> property and the syntax required is:</p>
 <pre class="cpp">
 
   <span class="type"><a href="qtableview.html">QTableView</a></span> {
@@ -1441,8 +1437,8 @@
 <h3 id="customizing-qtoolbutton">Customizing QToolButton</h3>
 <p>There are three types of QToolButtons.</p>
 <ul>
-<li>The <a href="qtoolbutton.html">QToolButton</a> has no menu. In this case, the <a href="qtoolbutton.html">QToolButton</a> is styled exactly like <a href="qpushbutton.html">QPushButton</a>. See <a href="stylesheet-examples.html#customizing-qpushbutton">Customizing QPushButton</a> for an example.</li>
-<li>The <a href="qtoolbutton.html">QToolButton</a> has a menu and has the <a href="qtoolbutton.html#popupMode-prop">QToolButton::popupMode</a> set to <a href="qtoolbutton.html#ToolButtonPopupMode-enum">QToolButton::DelayedPopup</a> or <a href="qtoolbutton.html#ToolButtonPopupMode-enum">QToolButton::InstantPopup</a>. In this case, the <a href="qtoolbutton.html">QToolButton</a> is styled exactly like a <a href="qpushbutton.html">QPushButton</a> with a menu. See <a href="stylesheet-examples.html#customizing-qpushbutton">Customizing QPushButton</a> for an example of the usage of the menu-indicator pseudo state.</li>
+<li>The <a href="qtoolbutton.html">QToolButton</a> has no menu. In this case, the <a href="qtoolbutton.html">QToolButton</a> is styled exactly like <a href="qpushbutton.html">QPushButton</a>. See <a href="stylesheet-examples.html">Customizing QPushButton</a> for an example.</li>
+<li>The <a href="qtoolbutton.html">QToolButton</a> has a menu and has the <a href="qtoolbutton.html#popupMode-prop">QToolButton::popupMode</a> set to <a href="qtoolbutton.html#ToolButtonPopupMode-enum">QToolButton::DelayedPopup</a> or <a href="qtoolbutton.html#ToolButtonPopupMode-enum">QToolButton::InstantPopup</a>. In this case, the <a href="qtoolbutton.html">QToolButton</a> is styled exactly like a <a href="qpushbutton.html">QPushButton</a> with a menu. See <a href="stylesheet-examples.html">Customizing QPushButton</a> for an example of the usage of the menu-indicator pseudo state.</li>
 <li>The <a href="qtoolbutton.html">QToolButton</a> has its <a href="qtoolbutton.html#popupMode-prop">QToolButton::popupMode</a> set to <a href="qtoolbutton.html#ToolButtonPopupMode-enum">QToolButton::MenuButtonPopup</a>. In this case, we style it as follows:</li>
 </ul>
 <pre class="cpp">
@@ -1638,9 +1634,6 @@
 </div>
 <p><b>See also </b><a href="qtwidgets-widgets-stylesheet-example.html">Style Sheet Example</a>, <a href="../qtgui/richtext-html-subset.html">Supported HTML Subset</a>, and <a href="qstyle.html">QStyle</a>.</p>
 <!-- @@@stylesheet-examples.html -->
-<p class="naviNextPrevious footerNavi">
-<a class="prevPage" href="stylesheet-reference.html">Qt Style Sheets Reference</a>
-</p>
         </div>
        </div>
    </div>