diff -Naur qtbase/src/gui/opengl/qopenglfunctions_3_3_core.h qtbase/src/gui/opengl/qopenglfunctions_3_3_core.h
--- qtbase/src/gui/opengl/qopenglfunctions_3_3_core.h	2019-08-31 01:29:31.000000000 -0700
+++ qtbase/src/gui/opengl/qopenglfunctions_3_3_core.h	2019-10-07 09:45:36.014265515 -0700
@@ -186,6 +186,42 @@
 
     // OpenGL 2.0 core functions
     void glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer);
+    void glVertexAttrib4usv(GLuint index, const GLushort *v);
+    void glVertexAttrib4uiv(GLuint index, const GLuint *v);
+    void glVertexAttrib4ubv(GLuint index, const GLubyte *v);
+    void glVertexAttrib4sv(GLuint index, const GLshort *v);
+    void glVertexAttrib4s(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
+    void glVertexAttrib4iv(GLuint index, const GLint *v);
+    void glVertexAttrib4fv(GLuint index, const GLfloat *v);
+    void glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
+    void glVertexAttrib4dv(GLuint index, const GLdouble *v);
+    void glVertexAttrib4d(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
+    void glVertexAttrib4bv(GLuint index, const GLbyte *v);
+    void glVertexAttrib4Nusv(GLuint index, const GLushort *v);
+    void glVertexAttrib4Nuiv(GLuint index, const GLuint *v);
+    void glVertexAttrib4Nubv(GLuint index, const GLubyte *v);
+    void glVertexAttrib4Nub(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
+    void glVertexAttrib4Nsv(GLuint index, const GLshort *v);
+    void glVertexAttrib4Niv(GLuint index, const GLint *v);
+    void glVertexAttrib4Nbv(GLuint index, const GLbyte *v);
+    void glVertexAttrib3sv(GLuint index, const GLshort *v);
+    void glVertexAttrib3s(GLuint index, GLshort x, GLshort y, GLshort z);
+    void glVertexAttrib3fv(GLuint index, const GLfloat *v);
+    void glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z);
+    void glVertexAttrib3dv(GLuint index, const GLdouble *v);
+    void glVertexAttrib3d(GLuint index, GLdouble x, GLdouble y, GLdouble z);
+    void glVertexAttrib2sv(GLuint index, const GLshort *v);
+    void glVertexAttrib2s(GLuint index, GLshort x, GLshort y);
+    void glVertexAttrib2fv(GLuint index, const GLfloat *v);
+    void glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y);
+    void glVertexAttrib2dv(GLuint index, const GLdouble *v);
+    void glVertexAttrib2d(GLuint index, GLdouble x, GLdouble y);
+    void glVertexAttrib1sv(GLuint index, const GLshort *v);
+    void glVertexAttrib1s(GLuint index, GLshort x);
+    void glVertexAttrib1fv(GLuint index, const GLfloat *v);
+    void glVertexAttrib1f(GLuint index, GLfloat x);
+    void glVertexAttrib1dv(GLuint index, const GLdouble *v);
+    void glVertexAttrib1d(GLuint index, GLdouble x);
     void glValidateProgram(GLuint program);
     void glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
     void glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value);
@@ -301,6 +337,26 @@
     void glGetVertexAttribIuiv(GLuint index, GLenum pname, GLuint *params);
     void glGetVertexAttribIiv(GLuint index, GLenum pname, GLint *params);
     void glVertexAttribIPointer(GLuint index, GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
+    void glVertexAttribI4usv(GLuint index, const GLushort *v);
+    void glVertexAttribI4ubv(GLuint index, const GLubyte *v);
+    void glVertexAttribI4sv(GLuint index, const GLshort *v);
+    void glVertexAttribI4bv(GLuint index, const GLbyte *v);
+    void glVertexAttribI4uiv(GLuint index, const GLuint *v);
+    void glVertexAttribI3uiv(GLuint index, const GLuint *v);
+    void glVertexAttribI2uiv(GLuint index, const GLuint *v);
+    void glVertexAttribI1uiv(GLuint index, const GLuint *v);
+    void glVertexAttribI4iv(GLuint index, const GLint *v);
+    void glVertexAttribI3iv(GLuint index, const GLint *v);
+    void glVertexAttribI2iv(GLuint index, const GLint *v);
+    void glVertexAttribI1iv(GLuint index, const GLint *v);
+    void glVertexAttribI4ui(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w);
+    void glVertexAttribI3ui(GLuint index, GLuint x, GLuint y, GLuint z);
+    void glVertexAttribI2ui(GLuint index, GLuint x, GLuint y);
+    void glVertexAttribI1ui(GLuint index, GLuint x);
+    void glVertexAttribI4i(GLuint index, GLint x, GLint y, GLint z, GLint w);
+    void glVertexAttribI3i(GLuint index, GLint x, GLint y, GLint z);
+    void glVertexAttribI2i(GLuint index, GLint x, GLint y);
+    void glVertexAttribI1i(GLuint index, GLint x);
     void glEndConditionalRender();
     void glBeginConditionalRender(GLuint id, GLenum mode);
     void glClampColor(GLenum target, GLenum clamp);
@@ -979,6 +1035,186 @@
     d_2_0_Core->f.VertexAttribPointer(index, size, type, normalized, stride, pointer);
 }
 
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4usv(GLuint index, const GLushort *v)
+{
+    d_2_0_Core->f.VertexAttrib4usv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4uiv(GLuint index, const GLuint *v)
+{
+    d_2_0_Core->f.VertexAttrib4uiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4ubv(GLuint index, const GLubyte *v)
+{
+    d_2_0_Core->f.VertexAttrib4ubv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4sv(GLuint index, const GLshort *v)
+{
+    d_2_0_Core->f.VertexAttrib4sv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4s(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w)
+{
+    d_2_0_Core->f.VertexAttrib4s(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4iv(GLuint index, const GLint *v)
+{
+    d_2_0_Core->f.VertexAttrib4iv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4fv(GLuint index, const GLfloat *v)
+{
+    d_2_0_Core->f.VertexAttrib4fv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
+{
+    d_2_0_Core->f.VertexAttrib4f(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4dv(GLuint index, const GLdouble *v)
+{
+    d_2_0_Core->f.VertexAttrib4dv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4d(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w)
+{
+    d_2_0_Core->f.VertexAttrib4d(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4bv(GLuint index, const GLbyte *v)
+{
+    d_2_0_Core->f.VertexAttrib4bv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nusv(GLuint index, const GLushort *v)
+{
+    d_2_0_Core->f.VertexAttrib4Nusv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nuiv(GLuint index, const GLuint *v)
+{
+    d_2_0_Core->f.VertexAttrib4Nuiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nubv(GLuint index, const GLubyte *v)
+{
+    d_2_0_Core->f.VertexAttrib4Nubv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nub(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w)
+{
+    d_2_0_Core->f.VertexAttrib4Nub(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nsv(GLuint index, const GLshort *v)
+{
+    d_2_0_Core->f.VertexAttrib4Nsv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Niv(GLuint index, const GLint *v)
+{
+    d_2_0_Core->f.VertexAttrib4Niv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib4Nbv(GLuint index, const GLbyte *v)
+{
+    d_2_0_Core->f.VertexAttrib4Nbv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3sv(GLuint index, const GLshort *v)
+{
+    d_2_0_Core->f.VertexAttrib3sv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3s(GLuint index, GLshort x, GLshort y, GLshort z)
+{
+    d_2_0_Core->f.VertexAttrib3s(index, x, y, z);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3fv(GLuint index, const GLfloat *v)
+{
+    d_2_0_Core->f.VertexAttrib3fv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z)
+{
+    d_2_0_Core->f.VertexAttrib3f(index, x, y, z);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3dv(GLuint index, const GLdouble *v)
+{
+    d_2_0_Core->f.VertexAttrib3dv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib3d(GLuint index, GLdouble x, GLdouble y, GLdouble z)
+{
+    d_2_0_Core->f.VertexAttrib3d(index, x, y, z);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2sv(GLuint index, const GLshort *v)
+{
+    d_2_0_Core->f.VertexAttrib2sv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2s(GLuint index, GLshort x, GLshort y)
+{
+    d_2_0_Core->f.VertexAttrib2s(index, x, y);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2fv(GLuint index, const GLfloat *v)
+{
+    d_2_0_Core->f.VertexAttrib2fv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y)
+{
+    d_2_0_Core->f.VertexAttrib2f(index, x, y);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2dv(GLuint index, const GLdouble *v)
+{
+    d_2_0_Core->f.VertexAttrib2dv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib2d(GLuint index, GLdouble x, GLdouble y)
+{
+    d_2_0_Core->f.VertexAttrib2d(index, x, y);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1sv(GLuint index, const GLshort *v)
+{
+    d_2_0_Core->f.VertexAttrib1sv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1s(GLuint index, GLshort x)
+{
+    d_2_0_Core->f.VertexAttrib1s(index, x);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1fv(GLuint index, const GLfloat *v)
+{
+    d_2_0_Core->f.VertexAttrib1fv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1f(GLuint index, GLfloat x)
+{
+    d_2_0_Core->f.VertexAttrib1f(index, x);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1dv(GLuint index, const GLdouble *v)
+{
+    d_2_0_Core->f.VertexAttrib1dv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttrib1d(GLuint index, GLdouble x)
+{
+    d_2_0_Core->f.VertexAttrib1d(index, x);
+}
+
 inline void QOpenGLFunctions_3_3_Core::glValidateProgram(GLuint program)
 {
     d_2_0_Core->f.ValidateProgram(program);
@@ -1538,6 +1774,106 @@
     d_3_0_Core->f.VertexAttribIPointer(index, size, type, stride, pointer);
 }
 
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4usv(GLuint index, const GLushort *v)
+{
+    d_3_0_Core->f.VertexAttribI4usv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4ubv(GLuint index, const GLubyte *v)
+{
+    d_3_0_Core->f.VertexAttribI4ubv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4sv(GLuint index, const GLshort *v)
+{
+    d_3_0_Core->f.VertexAttribI4sv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4bv(GLuint index, const GLbyte *v)
+{
+    d_3_0_Core->f.VertexAttribI4bv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4uiv(GLuint index, const GLuint *v)
+{
+    d_3_0_Core->f.VertexAttribI4uiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI3uiv(GLuint index, const GLuint *v)
+{
+    d_3_0_Core->f.VertexAttribI3uiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI2uiv(GLuint index, const GLuint *v)
+{
+    d_3_0_Core->f.VertexAttribI2uiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI1uiv(GLuint index, const GLuint *v)
+{
+    d_3_0_Core->f.VertexAttribI1uiv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4iv(GLuint index, const GLint *v)
+{
+    d_3_0_Core->f.VertexAttribI4iv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI3iv(GLuint index, const GLint *v)
+{
+    d_3_0_Core->f.VertexAttribI3iv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI2iv(GLuint index, const GLint *v)
+{
+    d_3_0_Core->f.VertexAttribI2iv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI1iv(GLuint index, const GLint *v)
+{
+    d_3_0_Core->f.VertexAttribI1iv(index, v);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4ui(GLuint index, GLuint x, GLuint y, GLuint z, GLuint w)
+{
+    d_3_0_Core->f.VertexAttribI4ui(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI3ui(GLuint index, GLuint x, GLuint y, GLuint z)
+{
+    d_3_0_Core->f.VertexAttribI3ui(index, x, y, z);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI2ui(GLuint index, GLuint x, GLuint y)
+{
+    d_3_0_Core->f.VertexAttribI2ui(index, x, y);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI1ui(GLuint index, GLuint x)
+{
+    d_3_0_Core->f.VertexAttribI1ui(index, x);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI4i(GLuint index, GLint x, GLint y, GLint z, GLint w)
+{
+    d_3_0_Core->f.VertexAttribI4i(index, x, y, z, w);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI3i(GLuint index, GLint x, GLint y, GLint z)
+{
+    d_3_0_Core->f.VertexAttribI3i(index, x, y, z);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI2i(GLuint index, GLint x, GLint y)
+{
+    d_3_0_Core->f.VertexAttribI2i(index, x, y);
+}
+
+inline void QOpenGLFunctions_3_3_Core::glVertexAttribI1i(GLuint index, GLint x)
+{
+    d_3_0_Core->f.VertexAttribI1i(index, x);
+}
+
 inline void QOpenGLFunctions_3_3_Core::glEndConditionalRender()
 {
     d_3_0_Core->f.EndConditionalRender();