diff --git a/src/gui/kernel/qplatformwindow.cpp b/src/gui/kernel/qplatformwindow.cpp
index 2a0cb1094c..60655b97f4 100644
--- a/src/gui/kernel/qplatformwindow.cpp
+++ b/src/gui/kernel/qplatformwindow.cpp
@@ -47,7 +47,7 @@
 #include <QtGui/qscreen.h>
 #include <private/qhighdpiscaling_p.h>
 #include <private/qwindow_p.h>
-
+#include <QDebug>
 
 QT_BEGIN_NAMESPACE
 
@@ -648,9 +648,12 @@ static inline const QScreen *effectiveScreen(const QWindow *window)
     const QList<QScreen *> siblings = screen->virtualSiblings();
     if (siblings.size() > 1) {
         const QPoint referencePoint = window->transientParent() ? window->transientParent()->geometry().center() : QCursor::pos();
+        qDebug() << __FUNCTION__ << "ref point from cursor" << referencePoint;
         for (const QScreen *sibling : siblings) {
-            if (sibling->geometry().contains(referencePoint))
+            if (sibling->geometry().contains(referencePoint)) {
+                qDebug() << __FUNCTION__ << "rets " << sibling;
                 return sibling;
+            }
         }
     }
 #endif
@@ -697,6 +700,8 @@ static QSize fixInitialSize(QSize size, const QWindow *w,
 QRect QPlatformWindow::initialGeometry(const QWindow *w,
     const QRect &initialGeometry, int defaultWidth, int defaultHeight)
 {
+    qDebug() << '\n' << __FUNCTION__ << w << w->isTopLevel() << w->screen()->name()
+             << initialGeometry;
     if (!w->isTopLevel()) {
         const qreal factor = QHighDpiScaling::factor(w);
         const QSize size = fixInitialSize(QHighDpi::fromNative(initialGeometry.size(), factor),
@@ -718,6 +723,7 @@ QRect QPlatformWindow::initialGeometry(const QWindow *w,
         rect.setSize(fixInitialSize(rect.size(), w, defaultWidth, defaultHeight));
     if (position) {
         const QRect availableGeometry = screen->availableGeometry();
+          qDebug() << __FUNCTION__ << "av=" << availableGeometry << screen;
         // Center unless the geometry ( + unknown window frame) is too large for the screen).
         if (rect.height() < (availableGeometry.height() * 8) / 9
                 && rect.width() < (availableGeometry.width() * 8) / 9) {
@@ -732,7 +738,9 @@ QRect QPlatformWindow::initialGeometry(const QWindow *w,
             }
         }
     }
-    return QHighDpi::toNativePixels(rect, screen);
+    auto  r= QHighDpi::toNativePixels(rect, screen);
+    qDebug() << __FUNCTION__ << w << "rets" << r << screen->name() << '\n';
+     return r;
 }
 
 /*!
diff --git a/src/gui/kernel/qwindow.cpp b/src/gui/kernel/qwindow.cpp
index b71a0c54aa..439a6c76dd 100644
--- a/src/gui/kernel/qwindow.cpp
+++ b/src/gui/kernel/qwindow.cpp
@@ -159,6 +159,7 @@ QWindow::QWindow(QScreen *targetScreen)
     : QObject(*new QWindowPrivate(), 0)
     , QSurface(QSurface::Window)
 {
+    qDebug() << __FUNCTION__ << targetScreen << "cur=" << QCursor::pos();
     Q_D(QWindow);
     d->init(targetScreen);
 }
@@ -186,6 +187,7 @@ static QWindow *nonDesktopParent(QWindow *parent)
 QWindow::QWindow(QWindow *parent)
     : QWindow(*new QWindowPrivate(), parent)
 {
+    qDebug() << __FUNCTION__ << "cur=" << QCursor::pos();
 }
 
 /*!
@@ -204,6 +206,7 @@ QWindow::QWindow(QWindowPrivate &dd, QWindow *parent)
     : QObject(dd, nonDesktopParent(parent))
     , QSurface(QSurface::Window)
 {
+    qDebug() << __FUNCTION__ << "cur=" << QCursor::pos();
     Q_D(QWindow);
     d->init();
 }
@@ -227,8 +230,9 @@ QWindow::~QWindow()
 }
 
 void QWindowPrivate::init(QScreen *targetScreen)
-{
+{    
     Q_Q(QWindow);
+    qDebug() << __FUNCTION__ << targetScreen << "cur=" << QCursor::pos();
 
     parentWindow = static_cast<QWindow *>(q->QObject::parent());
 
@@ -481,6 +485,7 @@ void QWindowPrivate::connectToScreen(QScreen *screen)
 void QWindowPrivate::emitScreenChangedRecursion(QScreen *newScreen)
 {
     Q_Q(QWindow);
+    qDebug() << __FUNCTION__ << q << newScreen->name();
     emit q->screenChanged(newScreen);
     for (QObject *child : q->children()) {
         if (child->isWindowType())
@@ -1470,6 +1475,7 @@ QSize QWindow::sizeIncrement() const
 */
 void QWindow::setMinimumSize(const QSize &size)
 {
+    qDebug() << __FUNCTION__ << this << size;
     Q_D(QWindow);
     QSize adjustedSize = QSize(qBound(0, size.width(), QWINDOWSIZE_MAX), qBound(0, size.height(), QWINDOWSIZE_MAX));
     if (d->minimumSize == adjustedSize)
@@ -1557,6 +1563,7 @@ void QWindow::setMinimumHeight(int h)
 */
 void QWindow::setMaximumSize(const QSize &size)
 {
+    qDebug() << __FUNCTION__ << this << size;
     Q_D(QWindow);
     QSize adjustedSize = QSize(qBound(0, size.width(), QWINDOWSIZE_MAX), qBound(0, size.height(), QWINDOWSIZE_MAX));
     if (d->maximumSize == adjustedSize)
@@ -1656,6 +1663,7 @@ void QWindow::setGeometry(const QRect &rect)
     Q_D(QWindow);
     d->positionAutomatic = false;
     const QRect oldRect = geometry();
+    qDebug() << __FUNCTION__ << this << oldRect << "->" << rect;
     if (rect == oldRect)
         return;
 
@@ -2015,6 +2023,7 @@ QScreen *QWindow::screen() const
 */
 void QWindow::setScreen(QScreen *newScreen)
 {
+    qDebug() << __FUNCTION__ << this << newScreen;
     Q_D(QWindow);
     if (!newScreen)
         newScreen = QGuiApplication::primaryScreen();
diff --git a/src/plugins/platforms/windows/qwindowscontext.cpp b/src/plugins/platforms/windows/qwindowscontext.cpp
index f7d04b667d..6138d6eed6 100644
--- a/src/plugins/platforms/windows/qwindowscontext.cpp
+++ b/src/plugins/platforms/windows/qwindowscontext.cpp
@@ -1218,6 +1218,7 @@ bool QWindowsContext::windowsProc(HWND hwnd, UINT message,
         platformWindow->handleResized(static_cast<int>(wParam));
         return true;
     case QtWindows::QuerySizeHints:
+        qDebug() << __FUNCTION__ << msg;
         platformWindow->getSizeHints(reinterpret_cast<MINMAXINFO *>(lParam));
         return true;// maybe available on some SDKs revisit WM_NCCALCSIZE
     case QtWindows::CalculateSize:
diff --git a/src/plugins/platforms/windows/qwindowswindow.cpp b/src/plugins/platforms/windows/qwindowswindow.cpp
index a4f4099aa6..e62af807f0 100644
--- a/src/plugins/platforms/windows/qwindowswindow.cpp
+++ b/src/plugins/platforms/windows/qwindowswindow.cpp
@@ -776,8 +776,10 @@ QWindowsWindowData
     QMargins invMargins = topLevel && hasFrame && QWindowsGeometryHint::positionIncludesFrame(w)
             ? invisibleMargins(QPoint(context->frameX, context->frameY)) : QMargins();
 
-    qCDebug(lcQpaWindows).nospace()
-        << "CreateWindowEx: " << w << " class=" << windowClassName << " title=" << title
+    qDebug().nospace().noquote()
+        << "CreateWindowEx: " << w  << " on \"" << w->screen()->name()
+        << "\" class=" << windowClassName << " title=" << title
+
         << '\n' << *this << "\nrequested: " << rect << ": "
         << context->frameWidth << 'x' <<  context->frameHeight
         << '+' << context->frameX << '+' << context->frameY
@@ -802,7 +804,7 @@ QWindowsWindowData
                                  pos.x(), pos.y(),
                                  context->frameWidth, context->frameHeight,
                                  parentHandle, nullptr, appinst, nullptr);
-    qCDebug(lcQpaWindows).nospace()
+    qDebug().nospace()
         << "CreateWindowEx: returns " << w << ' ' << result.hwnd << " obtained geometry: "
         << context->obtainedPos << context->obtainedSize << ' ' << context->margins;
 
@@ -1023,7 +1025,9 @@ void QWindowsGeometryHint::applyToMinMaxInfo(const QWindow *w,
     QSize minimumSize;
     QSize maximumSize;
     frameSizeConstraints(w, margins, &minimumSize, &maximumSize);
-    qCDebug(lcQpaWindows).nospace() << '>' << __FUNCTION__ << '<' << " min="
+    qDebug().nospace() << '>' << __FUNCTION__
+        << w << w->screen()
+        << '<' << " min="
         << minimumSize.width() << ',' << minimumSize.height()
         << " max=" << maximumSize.width() << ',' << maximumSize.height()
         << " margins=" << margins
@@ -1967,7 +1971,7 @@ void QWindowsBaseWindow::setGeometry_sys(const QRect &rect) const
     const QMargins margins = fullFrameMargins();
     const QRect frameGeometry = rect + margins;
 
-    qCDebug(lcQpaWindows) << '>' << __FUNCTION__ << window()
+    qDebug() << '>' << __FUNCTION__ << window()
         << "\n from " << geometry_sys() << " frame: "
         << margins << " to " <<rect
         << " new frame: " << frameGeometry;
@@ -2394,6 +2398,7 @@ bool QWindowsWindow::handleGeometryChangingMessage(MSG *message, const QWindow *
     const QRect correctedFrameGeometry = correctedGeometryF.toRect() + margins;
     if (correctedFrameGeometry == suggestedFrameGeometry)
         return false;
+    qDebug() << __FUNCTION__ << qWindow << suggestedFrameGeometry << "corr=" << correctedFrameGeometry;
     windowPos->x = correctedFrameGeometry.left();
     windowPos->y = correctedFrameGeometry.top();
     windowPos->cx = correctedFrameGeometry.width();
@@ -2632,6 +2637,7 @@ static int getBorderWidth(const QPlatformScreen *screen)
 
 void QWindowsWindow::getSizeHints(MINMAXINFO *mmi) const
 {
+    qDebug() << __FUNCTION__;
     // We don't apply the min/max size hint as we change the dpi, because we did not adjust the
     // QScreen of the window yet so we don't have the min/max with the right ratio
     if (!testFlag(QWindowsWindow::WithinDpiChanged))
diff --git a/src/widgets/kernel/qwidget.cpp b/src/widgets/kernel/qwidget.cpp
index 74aebd1223..69bd8944fa 100644
--- a/src/widgets/kernel/qwidget.cpp
+++ b/src/widgets/kernel/qwidget.cpp
@@ -3942,6 +3942,7 @@ void QWidget::setBaseSize(int basew, int baseh)
 
 void QWidget::setFixedSize(const QSize & s)
 {
+    qDebug() << __FUNCTION__ << this << s;
     setFixedSize(s.width(), s.height());
 }
 
@@ -6938,6 +6939,7 @@ QSize QWidget::frameSize() const
 
 void QWidget::move(const QPoint &p)
 {
+    qDebug() << __FUNCTION__ << this << p;
     Q_D(QWidget);
     setAttribute(Qt::WA_Moved);
     if (testAttribute(Qt::WA_WState_Created)) {
@@ -6998,6 +7000,7 @@ void QWidgetPrivate::fixPosIncludesFrame()
 
 void QWidget::resize(const QSize &s)
 {
+    qDebug() << __FUNCTION__ << this << s;
     Q_D(QWidget);
     setAttribute(Qt::WA_Resized);
     if (testAttribute(Qt::WA_WState_Created)) {