diff --git a/examples/sql/books/bookwindow.ui b/examples/sql/books/bookwindow.ui
index ce8f9f93..91f0fd3e 100644
--- a/examples/sql/books/bookwindow.ui
+++ b/examples/sql/books/bookwindow.ui
@@ -67,7 +67,7 @@
           <item row="0" column="0">
            <widget class="QLabel" name="label_5">
             <property name="text">
-             <string>&lt;b&gt;Title:&lt;/b&gt;</string>
+             <string>&lt;b&gt;Titleß:&lt;/b&gt;</string>
             </property>
            </widget>
           </item>
@@ -95,7 +95,7 @@
           <item row="2" column="0">
            <widget class="QLabel" name="label_3">
             <property name="text">
-             <string>&lt;b&gt;Genre:&lt;/b&gt;</string>
+             <string>&lt;b&gt;Gänre:&lt;/b&gt;</string>
             </property>
            </widget>
           </item>
@@ -132,7 +132,7 @@
           <item row="4" column="0">
            <widget class="QLabel" name="label">
             <property name="text">
-             <string>&lt;b&gt;Rating:&lt;/b&gt;</string>
+             <string>&lt;b&gt;Räting:&lt;/b&gt;</string>
             </property>
            </widget>
           </item>
diff --git a/examples/sql/books/ui_bookwindow.py b/examples/sql/books/ui_bookwindow.py
index 5eb412d9..f9d00d2f 100644
--- a/examples/sql/books/ui_bookwindow.py
+++ b/examples/sql/books/ui_bookwindow.py
@@ -22,63 +22,63 @@ class Ui_BookWindow(object):
         BookWindow.resize(601, 420)
         self.centralWidget = QWidget(BookWindow)
         self.centralWidget.setObjectName(u"centralWidget")
-        self.vboxLayout = QVBoxLayout(self.centralWidget);
+        self.vboxLayout = QVBoxLayout(self.centralWidget)
         self.vboxLayout.setSpacing(6)
         self.vboxLayout.setObjectName(u"vboxLayout")
-        self.vboxLayout.setContentsMargins(9, 9, 9, 9);
+        self.vboxLayout.setContentsMargins(9, 9, 9, 9)
         self.groupBox = QGroupBox(self.centralWidget)
         self.groupBox.setObjectName(u"groupBox")
-        self.vboxLayout1 = QVBoxLayout(self.groupBox);
+        self.vboxLayout1 = QVBoxLayout(self.groupBox)
         self.vboxLayout1.setSpacing(6)
         self.vboxLayout1.setObjectName(u"vboxLayout1")
-        self.vboxLayout1.setContentsMargins(9, 9, 9, 9);
+        self.vboxLayout1.setContentsMargins(9, 9, 9, 9)
         self.bookTable = QTableView(self.groupBox)
         self.bookTable.setObjectName(u"bookTable")
         self.bookTable.setSelectionBehavior(QAbstractItemView.SelectRows)
 
-        self.vboxLayout1.addWidget(self.bookTable);
+        self.vboxLayout1.addWidget(self.bookTable)
 
         self.groupBox_2 = QGroupBox(self.groupBox)
         self.groupBox_2.setObjectName(u"groupBox_2")
-        self.formLayout = QFormLayout(self.groupBox_2);
+        self.formLayout = QFormLayout(self.groupBox_2)
         self.formLayout.setObjectName(u"formLayout")
         self.label_5 = QLabel(self.groupBox_2)
         self.label_5.setObjectName(u"label_5")
 
-        self.formLayout.setWidget(0, QFormLayout.LabelRole, self.label_5);
+        self.formLayout.setWidget(0, QFormLayout.LabelRole, self.label_5)
 
         self.titleEdit = QLineEdit(self.groupBox_2)
         self.titleEdit.setObjectName(u"titleEdit")
         self.titleEdit.setEnabled(True)
 
-        self.formLayout.setWidget(0, QFormLayout.FieldRole, self.titleEdit);
+        self.formLayout.setWidget(0, QFormLayout.FieldRole, self.titleEdit)
 
         self.label_2 = QLabel(self.groupBox_2)
         self.label_2.setObjectName(u"label_2")
 
-        self.formLayout.setWidget(1, QFormLayout.LabelRole, self.label_2);
+        self.formLayout.setWidget(1, QFormLayout.LabelRole, self.label_2)
 
         self.authorEdit = QComboBox(self.groupBox_2)
         self.authorEdit.setObjectName(u"authorEdit")
         self.authorEdit.setEnabled(True)
 
-        self.formLayout.setWidget(1, QFormLayout.FieldRole, self.authorEdit);
+        self.formLayout.setWidget(1, QFormLayout.FieldRole, self.authorEdit)
 
         self.label_3 = QLabel(self.groupBox_2)
         self.label_3.setObjectName(u"label_3")
 
-        self.formLayout.setWidget(2, QFormLayout.LabelRole, self.label_3);
+        self.formLayout.setWidget(2, QFormLayout.LabelRole, self.label_3)
 
         self.genreEdit = QComboBox(self.groupBox_2)
         self.genreEdit.setObjectName(u"genreEdit")
         self.genreEdit.setEnabled(True)
 
-        self.formLayout.setWidget(2, QFormLayout.FieldRole, self.genreEdit);
+        self.formLayout.setWidget(2, QFormLayout.FieldRole, self.genreEdit)
 
         self.label_4 = QLabel(self.groupBox_2)
         self.label_4.setObjectName(u"label_4")
 
-        self.formLayout.setWidget(3, QFormLayout.LabelRole, self.label_4);
+        self.formLayout.setWidget(3, QFormLayout.LabelRole, self.label_4)
 
         self.yearEdit = QSpinBox(self.groupBox_2)
         self.yearEdit.setObjectName(u"yearEdit")
@@ -86,24 +86,24 @@ class Ui_BookWindow(object):
         self.yearEdit.setMinimum(-1000)
         self.yearEdit.setMaximum(2100)
 
-        self.formLayout.setWidget(3, QFormLayout.FieldRole, self.yearEdit);
+        self.formLayout.setWidget(3, QFormLayout.FieldRole, self.yearEdit)
 
         self.label = QLabel(self.groupBox_2)
         self.label.setObjectName(u"label")
 
-        self.formLayout.setWidget(4, QFormLayout.LabelRole, self.label);
+        self.formLayout.setWidget(4, QFormLayout.LabelRole, self.label)
 
         self.ratingEdit = QSpinBox(self.groupBox_2)
         self.ratingEdit.setObjectName(u"ratingEdit")
         self.ratingEdit.setMaximum(5)
 
-        self.formLayout.setWidget(4, QFormLayout.FieldRole, self.ratingEdit);
+        self.formLayout.setWidget(4, QFormLayout.FieldRole, self.ratingEdit)
 
 
-        self.vboxLayout1.addWidget(self.groupBox_2);
+        self.vboxLayout1.addWidget(self.groupBox_2)
 
 
-        self.vboxLayout.addWidget(self.groupBox);
+        self.vboxLayout.addWidget(self.groupBox)
 
         BookWindow.setCentralWidget(self.centralWidget)
         QWidget.setTabOrder(self.bookTable, self.titleEdit)
@@ -120,10 +120,11 @@ class Ui_BookWindow(object):
         BookWindow.setWindowTitle(QCoreApplication.translate("BookWindow", u"Books", None))
         self.groupBox.setTitle("")
         self.groupBox_2.setTitle(QCoreApplication.translate("BookWindow", u"Details", None))
-        self.label_5.setText(QCoreApplication.translate("BookWindow", u"<b>Title:</b>", None))
+        self.label_5.setText(QCoreApplication.translate("BookWindow", u"<b>Title\u00df:</b>", None))
         self.label_2.setText(QCoreApplication.translate("BookWindow", u"<b>Author: </b>", None))
-        self.label_3.setText(QCoreApplication.translate("BookWindow", u"<b>Genre:</b>", None))
+        self.label_3.setText(QCoreApplication.translate("BookWindow", u"<b>G\u00e4nre:</b>", None))
         self.label_4.setText(QCoreApplication.translate("BookWindow", u"<b>Year:</b>", None))
         self.yearEdit.setPrefix("")
-        self.label.setText(QCoreApplication.translate("BookWindow", u"<b>Rating:</b>", None))
+        self.label.setText(QCoreApplication.translate("BookWindow", u"<b>R\u00e4ting:</b>", None))
     # retranslateUi
+