diff --git a/src/quick/items/qquickdrag.cpp b/src/quick/items/qquickdrag.cpp
index 32695e9245..560e56e53e 100644
--- a/src/quick/items/qquickdrag.cpp
+++ b/src/quick/items/qquickdrag.cpp
@@ -54,6 +54,7 @@
 
 #include <qpa/qplatformdrag.h>
 #include <QtGui/qdrag.h>
+#include <QDebug>
 
 QT_BEGIN_NAMESPACE
 
@@ -204,6 +205,7 @@ void QQuickDragAttachedPrivate::deliverEnterEvent()
     if (window) {
         QPoint scenePos = attachedItem->mapToScene(hotSpot).toPoint();
         QDragEnterEvent event(scenePos, mimeData->m_supportedActions, mimeData, Qt::NoButton, Qt::NoModifier);
+        qDebug() << __FUNCTION__ << proposedAction;
         QQuickDropEventEx::setProposedAction(&event, proposedAction);
         deliverEvent(window, &event);
     }
@@ -218,6 +220,7 @@ void QQuickDragAttachedPrivate::deliverMoveEvent()
         QPoint scenePos = attachedItem->mapToScene(hotSpot).toPoint();
         QDragMoveEvent event(scenePos, mimeData->m_supportedActions, mimeData, Qt::NoButton, Qt::NoModifier);
         QQuickDropEventEx::setProposedAction(&event, proposedAction);
+        qDebug() << __FUNCTION__ << proposedAction;
         deliverEvent(window, &event);
         if (target != dragGrabber.target()) {
             target = dragGrabber.target();
@@ -304,6 +307,7 @@ bool QQuickDragAttached::isActive() const
 
 void QQuickDragAttached::setActive(bool active)
 {
+    qDebug() << __FUNCTION__ << active;
     Q_D(QQuickDragAttached);
     if (d->active != active) {
         if (d->inEvent)
@@ -627,6 +631,7 @@ void QQuickDragAttachedPrivate::start(Qt::DropActions supportedActions)
 
 void QQuickDragAttached::start(QQmlV4Function *args)
 {
+    qDebug() << __FUNCTION__ ;
     Q_D(QQuickDragAttached);
     if (d->inEvent) {
         qmlWarning(this) << "start() cannot be called from within a drag event handler";
@@ -693,6 +698,7 @@ int QQuickDragAttached::drop()
 
         QDropEvent event(
                 scenePos, d->mimeData->m_supportedActions, d->mimeData, Qt::NoButton, Qt::NoModifier);
+        qDebug() << __FUNCTION__ << scenePos;
         QQuickDropEventEx::setProposedAction(&event, d->proposedAction);
         d->deliverEvent(d->window, &event);
 
@@ -719,6 +725,7 @@ int QQuickDragAttached::drop()
 
 void QQuickDragAttached::cancel()
 {
+    qDebug() << __FUNCTION__;
     Q_D(QQuickDragAttached);
 
     if (d->inEvent) {
diff --git a/src/quick/items/qquickmousearea.cpp b/src/quick/items/qquickmousearea.cpp
index f54858e4eb..4bb444c413 100644
--- a/src/quick/items/qquickmousearea.cpp
+++ b/src/quick/items/qquickmousearea.cpp
@@ -50,6 +50,7 @@
 #include <QtGui/private/qguiapplication_p.h>
 #include <QtGui/qevent.h>
 #include <QtGui/qstylehints.h>
+#include <QtDebug>
 
 #include <float.h>
 
@@ -668,6 +669,7 @@ void QQuickMouseArea::mousePressEvent(QMouseEvent *event)
         d->longPress = false;
         d->saveEvent(event);
 #if QT_CONFIG(quick_draganddrop)
+        qDebug() << __FUNCTION__ << "drag->setActive(false)";
         if (d->drag)
             d->drag->setActive(false);
 #endif
@@ -712,8 +714,10 @@ void QQuickMouseArea::mouseMoveEvent(QMouseEvent *event)
             curLocalPos = event->windowPos();
         }
 
-        if (keepMouseGrab() && d->stealMouse && d->overThreshold && !d->drag->active())
+        if (keepMouseGrab() && d->stealMouse && d->overThreshold && !d->drag->active()) {
+            qDebug() << __FUNCTION__ << "drag->setActive(true)" << event;
             d->drag->setActive(true);
+        }
 
         QPointF startPos = d->drag->target()->parentItem()
                 ? d->drag->target()->parentItem()->mapFromScene(d->targetStartPos)
@@ -783,6 +787,8 @@ void QQuickMouseArea::mouseReleaseEvent(QMouseEvent *event)
     Q_D(QQuickMouseArea);
     d->stealMouse = false;
     d->overThreshold = false;
+    qDebug() << __FUNCTION__ << event->button()
+             << "pres=" << d->pressed;
     if (!d->enabled && !d->pressed) {
         QQuickItem::mouseReleaseEvent(event);
     } else {
@@ -791,6 +797,7 @@ void QQuickMouseArea::mouseReleaseEvent(QMouseEvent *event)
         if (!d->pressed) {
             // no other buttons are pressed
 #if QT_CONFIG(quick_draganddrop)
+            qDebug() << __FUNCTION__ << "drag->setActive(false)";
             if (d->drag)
                 d->drag->setActive(false);
 #endif