diff --git a/src/android/java/src/org/qtproject/qt5/android/bindings/QtLoader.java b/src/android/java/src/org/qtproject/qt5/android/bindings/QtLoader.java
index 1e72aa3841..98e919cdae 100644
--- a/src/android/java/src/org/qtproject/qt5/android/bindings/QtLoader.java
+++ b/src/android/java/src/org/qtproject/qt5/android/bindings/QtLoader.java
@@ -216,8 +216,10 @@ public abstract class QtLoader {
     private void loadApplication(Bundle loaderParams)
     {
         try {
+            Log.e(QtApplication.QtTAG, "Trying to load the app #1");
             final int errorCode = loaderParams.getInt(ERROR_CODE_KEY);
             if (errorCode != 0) {
+                Log.e(QtApplication.QtTAG, "Trying to load the app #2");
                 if (errorCode == INCOMPATIBLE_MINISTRO_VERSION) {
                     downloadUpgradeMinistro(loaderParams.getString(ERROR_MESSAGE_KEY));
                     return;
@@ -235,7 +237,7 @@ public abstract class QtLoader {
                 errorDialog.show();
                 return;
             }
-
+Log.e(QtApplication.QtTAG, "Trying to load the app #3");
             // add all bundled Qt libs to loader params
             ArrayList<String> libs = new ArrayList<String>();
             if (m_contextInfo.metaData.containsKey("android.app.bundled_libs_resource_id")) {
@@ -251,7 +253,7 @@ public abstract class QtLoader {
 
             loaderParams.putStringArrayList(BUNDLED_LIBRARIES_KEY, libs);
             loaderParams.putInt(NECESSITAS_API_LEVEL_KEY, NECESSITAS_API_LEVEL);
-
+Log.e(QtApplication.QtTAG, "Trying to load the app #4");
             // load and start QtLoader class
             DexClassLoader classLoader = new DexClassLoader(loaderParams.getString(DEX_PATH_KEY), // .jar/.apk files
                     m_context.getDir("outdex", Context.MODE_PRIVATE).getAbsolutePath(), // directory where optimized DEX files should be written.
@@ -266,14 +268,15 @@ public abstract class QtLoader {
                     Bundle.class);
             if (!(Boolean)prepareAppMethod.invoke(qtLoader, m_context, classLoader, loaderParams))
                 throw new Exception("");
-
+Log.e(QtApplication.QtTAG, "Trying to load the app #5");
             QtApplication.setQtContextDelegate(m_delegateClass, qtLoader);
 
             Method startAppMethod=qtLoader.getClass().getMethod("startApplication");
             if (!(Boolean)startAppMethod.invoke(qtLoader))
                 throw new Exception("");
-
+Log.e(QtApplication.QtTAG, "Trying to load the app #6");
         } catch (Exception e) {
+        Log.e(QtApplication.QtTAG, "Trying to load the app #7");
             e.printStackTrace();
             AlertDialog errorDialog = new AlertDialog.Builder(m_context).create();
             if (m_contextInfo.metaData.containsKey("android.app.fatal_error_msg"))
@@ -359,6 +362,7 @@ public abstract class QtLoader {
     public void startApp(final boolean firstStart)
     {
         try {
+            Log.e(QtApplication.QtTAG, "Trying to start the app #1");
             if (m_contextInfo.metaData.containsKey("android.app.qt_sources_resource_id")) {
                 int resourceId = m_contextInfo.metaData.getInt("android.app.qt_sources_resource_id");
                 m_sources = m_context.getResources().getStringArray(resourceId);
@@ -374,6 +378,7 @@ public abstract class QtLoader {
 
             if (m_contextInfo.metaData.containsKey("android.app.use_local_qt_libs")
                     && m_contextInfo.metaData.getInt("android.app.use_local_qt_libs") == 1) {
+                        Log.e(QtApplication.QtTAG, "Trying to start the app #2");
                 ArrayList<String> libraryList = new ArrayList<String>();
 
                 boolean apkDeployFromSystem = false;
@@ -398,6 +403,7 @@ public abstract class QtLoader {
                     if (systemLibraryDir.exists() && systemLibraryDir.isDirectory() && systemLibraryDir.list().length > 0)
                         libsDir = systemLibsPrefix;
                 } else {
+                Log.e(QtApplication.QtTAG, "Trying to start the app #3");
                     String nativeLibraryPrefix = m_context.getApplicationInfo().nativeLibraryDir + "/";
                     File nativeLibraryDir = new File(nativeLibraryPrefix);
                     if (nativeLibraryDir.exists() && nativeLibraryDir.isDirectory() && nativeLibraryDir.list().length > 0) {
@@ -412,6 +418,7 @@ public abstract class QtLoader {
 
 
                 if (m_qtLibs != null) {
+                    Log.e(QtApplication.QtTAG, "Trying to start the app #4");
                     String libPrefix = libsDir + "lib";
                     for (String lib : m_qtLibs)
                         libraryList.add(libPrefix + lib + ".so");
@@ -429,7 +436,7 @@ public abstract class QtLoader {
                     if (bundledLibsDir != null)
                         ENVIRONMENT_VARIABLES += "\tQT_BUNDLED_LIBS_PATH=" + bundledLibsDir;
                 }
-
+Log.e(QtApplication.QtTAG, "Trying to start the app #5");
                 Bundle loaderParams = new Bundle();
                 loaderParams.putInt(ERROR_CODE_KEY, 0);
                 loaderParams.putString(DEX_PATH_KEY, new String());
@@ -446,6 +453,7 @@ public abstract class QtLoader {
 
                 String extractOption = "default";
                 if (m_contextInfo.metaData.containsKey("android.app.extract_android_style")) {
+                    Log.e(QtApplication.QtTAG, "Trying to start the app #6");
                     extractOption = m_contextInfo.metaData.getString("android.app.extract_android_style");
                     if (!extractOption.equals("default") && !extractOption.equals("full") && !extractOption.equals("minimal") && !extractOption.equals("none")) {
                         Log.e(QtApplication.QtTAG, "Invalid extract_android_style option \"" + extractOption + "\", defaulting to \"default\"");
@@ -463,7 +471,7 @@ public abstract class QtLoader {
                         extractOption = "none";
                     }
                 }
-
+Log.e(QtApplication.QtTAG, "Trying to start the app #7");
                 if (!(new File(stylePath)).exists() && !extractOption.equals("none")) {
                     loaderParams.putString(EXTRACT_STYLE_KEY, stylePath);
                     loaderParams.putBoolean(EXTRACT_STYLE_MINIMAL_KEY, extractOption.equals("minimal"));
@@ -490,7 +498,7 @@ public abstract class QtLoader {
                         else
                             appParams += '\t' + parameters;
                 }
-
+Log.e(QtApplication.QtTAG, "Trying to start the app #8");
                 if (m_contextInfo.metaData.containsKey("android.app.arguments")) {
                     String parameters = m_contextInfo.metaData.getString("android.app.arguments");
                     if (appParams == null)
@@ -505,14 +513,16 @@ public abstract class QtLoader {
                 loadApplication(loaderParams);
                 return;
             }
-
+Log.e(QtApplication.QtTAG, "Trying to start the app #9");
             try {
+                Log.e(QtApplication.QtTAG, "Trying to start the app #10");
                 if (!m_context.bindService(new Intent(org.kde.necessitas.ministro.IMinistro.class.getCanonicalName()),
                         m_ministroConnection,
                         Context.BIND_AUTO_CREATE)) {
                     throw new SecurityException("");
                 }
             } catch (Exception e) {
+            Log.e(QtApplication.QtTAG, "Trying to start the app #11");
                 if (firstStart) {
                     String msg = "This application requires Ministro service. Would you like to install it?";
                     if (m_contextInfo.metaData.containsKey("android.app.ministro_needed_msg"))
@@ -523,6 +533,7 @@ public abstract class QtLoader {
                 }
             }
         } catch (Exception e) {
+        Log.e(QtApplication.QtTAG, "Trying to start the app #12");
             Log.e(QtApplication.QtTAG, "Can't create main activity", e);
         }
     }